| trimseq

## Wiki

The master copies of EMBOSS documentation are available at http://emboss.open-bio.org/wiki/Appdocs on the EMBOSS Wiki.

Please help by correcting and extending the Wiki pages.

## Function

Remove unwanted characters from start and end of sequence(s)

## Description

trimseq reads one or more sequences and writes the same sequences out, but removing any regions at the start and / or end that contain unwanted characters. These include gap characters (where occur the sequences have been aligned), `X`'s and `N`'s (in nucleotide sequences), `*`'s (optionally) and (optionally) IUPAC ambiguity codes.

## Usage

Here is a sample session with trimseq

    % trimseq untrimmed.seq trim1.seq -window 1 -percent 100
    Remove unwanted characters from start and end of sequence(s)

Go to the input files for this example
Go to the output files for this example

Example 2

    % trimseq untrimmed.seq trim2.seq -window 5 -percent 40
    Remove unwanted characters from start and end of sequence(s)

Go to the output files for this example

Example 3

    % trimseq untrimmed.seq trim3.seq -window 5 -percent 50
    Remove unwanted characters from start and end of sequence(s)

Go to the output files for this example

Example 4

    % trimseq untrimmed.seq trim4.seq -window 5 -percent 50 -strict
    Remove unwanted characters from start and end of sequence(s)

Go to the output files for this example

Example 5

    % trimseq untrimmed.seq trim5.seq -window 5 -percent 50 -strict -noright
    Remove unwanted characters from start and end of sequence(s)

Go to the output files for this example

## Command line arguments

    Remove unwanted characters from start and end of sequence(s)
    Version: EMBOSS:6.6.0.0

       Standard (Mandatory) qualifiers:
      [-sequence]          seqall     (Gapped) sequence(s) filename and optional
                                      format, or reference (input USA)
      [-outseq]            seqoutall  [.] Sequence set(s)
                                      filename and optional format (output USA)

       Additional (Optional) qualifiers:
       -window             integer    [1] This determines the size of the region
                                      that is considered when deciding whether the
                                      percentage of ambiguity is greater than the
                                      threshold. A value of 5 means that a region
                                      of 5 letters in the sequence is shifted
                                      along the sequence from the ends and
                                      trimming is done only if there is a greater
                                      or equal percentage of ambiguity than the
                                      threshold percentage. (Integer 1 or more)
       -percent            float      [100.0] This is the threshold of the
                                      percentage ambiguity in the window required
                                      in order to trim a sequence. (Any numeric
                                      value)
       -strict             boolean    [N] In nucleic sequences, trim off not only
                                      N's and X's, but also the nucleotide IUPAC
                                      ambiguity codes M, R, W, S, Y, K, V, H, D
                                      and B. In protein sequences, trim off not
                                      only X's but also B and Z.
       -star               boolean    [N] In protein sequences, trim off not only
                                      X's, but also the *'s

       Advanced (Unprompted) qualifiers:
       -[no]left           boolean    [Y] Trim at the start
       -[no]right          boolean    [Y] Trim at the end

       Associated qualifiers:

       "-sequence" associated qualifiers
       -sbegin1            integer    Start of each sequence to be used
       -send1              integer    End of each sequence to be used
       -sreverse1          boolean    Reverse (if DNA)
       -sask1              boolean    Ask for begin/end/reverse
       -snucleotide1       boolean    Sequence is nucleotide
       -sprotein1          boolean    Sequence is protein
       -slower1            boolean    Make lower case
       -supper1            boolean    Make upper case
       -scircular1         boolean    Sequence is circular
       -squick1            boolean    Read id and sequence only
       -sformat1           string     Input sequence format
       -iquery1            string     Input query fields or ID list
       -ioffset1           integer    Input start position offset
       -sdbname1           string     Database name
       -sid1               string     Entryname
       -ufo1               string     UFO features
       -fformat1           string     Features format
       -fopenfile1         string     Features file name

       "-outseq" associated qualifiers
       -osformat2          string     Output seq format
       -osextension2       string     File name extension
       -osname2            string     Base file name
       -osdirectory2       string     Output directory
       -osdbname2          string     Database name to add
       -ossingle2          boolean    Separate file for each entry
       -oufo2              string     UFO features
       -offormat2          string     Features format
       -ofname2            string     Features file name
       -ofdirectory2       string     Output directory

       General qualifiers:
       -auto               boolean    Turn off prompts
       -stdout             boolean    Write first file to standard output
       -filter             boolean    Read first file from standard input, write
                                      first file to standard output
       -options            boolean    Prompt for standard and additional values
       -debug              boolean    Write debug output to program.dbg
       -verbose            boolean    Report some/full command line options
       -help               boolean    Report command line options and exit. More
                                      information on associated and general
                                      qualifiers can be found with -help -verbose
       -warning            boolean    Report warnings
       -error              boolean    Report errors
       -fatal              boolean    Report fatal errors
       -die                boolean    Report dying program messages
       -version            boolean    Report version number and exit

Qualifier | Type | Description | Allowed values | Default
--- | --- | --- | --- | ---
Standard (Mandatory) qualifiers
[-sequence] (Parameter 1) | seqall | (Gapped) sequence(s) filename and optional format, or reference (input USA) | Readable sequence(s) | Required
[-outseq] (Parameter 2) | seqoutall | Sequence set(s) filename and optional format (output USA) | Writeable sequence(s) | <*>.format
Additional (Optional) qualifiers
-window | integer | This determines the size of the region that is considered when deciding whether the percentage of ambiguity is greater than the threshold. A value of 5 means that a region of 5 letters in the sequence is shifted along the sequence from the ends and trimming is done only if there is a greater or equal percentage of ambiguity than the threshold percentage. | Integer 1 or more | 1
-percent | float | This is the threshold of the percentage ambiguity in the window required in order to trim a sequence. | Any numeric value | 100.0
-strict | boolean | In nucleic sequences, trim off not only N's and X's, but also the nucleotide IUPAC ambiguity codes M, R, W, S, Y, K, V, H, D and B. In protein sequences, trim off not only X's but also B and Z. | Boolean value Yes/No | No
-star | boolean | In protein sequences, trim off not only X's, but also the *'s | Boolean value Yes/No | No
Advanced (Unprompted) qualifiers
-[no]left | boolean | Trim at the start | Boolean value Yes/No | Yes
-[no]right | boolean | Trim at the end | Boolean value Yes/No | Yes
Associated qualifiers
"-sequence" associated seqall qualifiers
-sbegin1 -sbegin_sequence | integer | Start of each sequence to be used | Any integer value | 0
-send1 -send_sequence | integer | End of each sequence to be used | Any integer value | 0
-sreverse1 -sreverse_sequence | boolean | Reverse (if DNA) | Boolean value Yes/No | N
-sask1 -sask_sequence | boolean | Ask for begin/end/reverse | Boolean value Yes/No | N
-snucleotide1 -snucleotide_sequence | boolean | Sequence is nucleotide | Boolean value Yes/No | N
-sprotein1 -sprotein_sequence | boolean | Sequence is protein | Boolean value Yes/No | N
-slower1 -slower_sequence | boolean | Make lower case | Boolean value Yes/No | N
-supper1 -supper_sequence | boolean | Make upper case | Boolean value Yes/No | N
-scircular1 -scircular_sequence | boolean | Sequence is circular | Boolean value Yes/No | N
-squick1 -squick_sequence | boolean | Read id and sequence only | Boolean value Yes/No | N
-sformat1 -sformat_sequence | string | Input sequence format | Any string |
-iquery1 -iquery_sequence | string | Input query fields or ID list | Any string |
-ioffset1 -ioffset_sequence | integer | Input start position offset | Any integer value | 0
-sdbname1 -sdbname_sequence | string | Database name | Any string |
-sid1 -sid_sequence | string | Entryname | Any string |
-ufo1 -ufo_sequence | string | UFO features | Any string |
-fformat1 -fformat_sequence | string | Features format | Any string |
-fopenfile1 -fopenfile_sequence | string | Features file name | Any string |
"-outseq" associated seqoutall qualifiers
-osformat2 -osformat_outseq | string | Output seq format | Any string |
-osextension2 -osextension_outseq | string | File name extension | Any string |
-osname2 -osname_outseq | string | Base file name | Any string |
-osdirectory2 -osdirectory_outseq | string | Output directory | Any string |
-osdbname2 -osdbname_outseq | string | Database name to add | Any string |
-ossingle2 -ossingle_outseq | boolean | Separate file for each entry | Boolean value Yes/No | N
-oufo2 -oufo_outseq | string | UFO features | Any string |
-offormat2 -offormat_outseq | string | Features format | Any string |
-ofname2 -ofname_outseq | string | Features file name | Any string |
-ofdirectory2 -ofdirectory_outseq | string | Output directory | Any string |
General qualifiers
-auto | boolean | Turn off prompts | Boolean value Yes/No | N
-stdout | boolean | Write first file to standard output | Boolean value Yes/No | N
-filter | boolean | Read first file from standard input, write first file to standard output | Boolean value Yes/No | N
-options | boolean | Prompt for standard and additional values | Boolean value Yes/No | N
-debug | boolean | Write debug output to program.dbg | Boolean value Yes/No | N
-verbose | boolean | Report some/full command line options | Boolean value Yes/No | Y
-help | boolean | Report command line options and exit. More information on associated and general qualifiers can be found with -help -verbose | Boolean value Yes/No | N
-warning | boolean | Report warnings | Boolean value Yes/No | Y
-error | boolean | Report errors | Boolean value Yes/No | Y
-fatal | boolean | Report fatal errors | Boolean value Yes/No | Y
-die | boolean | Report dying program messages | Boolean value Yes/No | Y
-version | boolean | Report version number and exit | Boolean value Yes/No | N

## Input file format

Normal sequence.

### Input files for usage example

### File: untrimmed.seq

    >myseq
    ...ttyyyctttctcgactccatcttcgcggtagctgggaccgccgttcagtcgccaatatgc
    agctctttgtccgcgcccaggagctacacaccttcgaggtgaccggccaggaaacggtcg
    cccagatcaaggctcatgtagcctcactggagggcattgccccggaagatcaagtcgtgc
    tcctggcaggcgcgcccctggaggatgaggccactctgggccagtgcggggtggaggccc
    tgactaccctggaagtagcaggccgcatgcttggaggtaaagttcatggttccctggccc
    gtgctggaaaagtgagaggtcagactcctaaggtggccaaacaggagaagaagaagaaga
    agacaggtcgggctaagcggcggatgcagtacaaccggcgctttgtcaacgttgtgccca
    cctttggcaagaagaagggccccaatgccaactcttaagtcttttgtaattctggctttc
    tctaataaaaaagccacttagttca.gnntcynnnnnn

## Output file format

Normal sequence file.

### Output files for usage example

### File: trim1.seq

    >myseq
    ttyyyctttctcgactccatcttcgcggtagctgggaccgccgttcagtcgccaatatgc
    agctctttgtccgcgcccaggagctacacaccttcgaggtgaccggccaggaaacggtcg
    cccagatcaaggctcatgtagcctcactggagggcattgccccggaagatcaagtcgtgc
    tcctggcaggcgcgcccctggaggatgaggccactctgggccagtgcggggtggaggccc
    tgactaccctggaagtagcaggccgcatgcttggaggtaaagttcatggttccctggccc
    gtgctggaaaagtgagaggtcagactcctaaggtggccaaacaggagaagaagaagaaga
    agacaggtcgggctaagcggcggatgcagtacaaccggcgctttgtcaacgttgtgccca
    cctttggcaagaagaagggccccaatgccaactcttaagtcttttgtaattctggctttc
    tctaataaaaaagccacttagttca-gnntcy

### Output files for usage example 2

### File: trim2.seq

    >myseq
    ttyyyctttctcgactccatcttcgcggtagctgggaccgccgttcagtcgccaatatgc
    agctctttgtccgcgcccaggagctacacaccttcgaggtgaccggccaggaaacggtcg
    cccagatcaaggctcatgtagcctcactggagggcattgccccggaagatcaagtcgtgc
    tcctggcaggcgcgcccctggaggatgaggccactctgggccagtgcggggtggaggccc
    tgactaccctggaagtagcaggccgcatgcttggaggtaaagttcatggttccctggccc
    gtgctggaaaagtgagaggtcagactcctaaggtggccaaacaggagaagaagaagaaga
    agacaggtcgggctaagcggcggatgcagtacaaccggcgctttgtcaacgttgtgccca
    cctttggcaagaagaagggccccaatgccaactcttaagtcttttgtaattctggctttc
    tctaataaaaaagccacttagttca-g

### Output files for usage example 3

### File: trim3.seq

    >myseq
    ttyyyctttctcgactccatcttcgcggtagctgggaccgccgttcagtcgccaatatgc
    agctctttgtccgcgcccaggagctacacaccttcgaggtgaccggccaggaaacggtcg
    cccagatcaaggctcatgtagcctcactggagggcattgccccggaagatcaagtcgtgc
    tcctggcaggcgcgcccctggaggatgaggccactctgggccagtgcggggtggaggccc
    tgactaccctggaagtagcaggccgcatgcttggaggtaaagttcatggttccctggccc
    gtgctggaaaagtgagaggtcagactcctaaggtggccaaacaggagaagaagaagaaga
    agacaggtcgggctaagcggcggatgcagtacaaccggcgctttgtcaacgttgtgccca
    cctttggcaagaagaagggccccaatgccaactcttaagtcttttgtaattctggctttc
    tctaataaaaaagccacttagttca-gnntcy

### Output files for usage example 4

### File: trim4.seq

    >myseq
    ctttctcgactccatcttcgcggtagctgggaccgccgttcagtcgccaatatgcagctc
    tttgtccgcgcccaggagctacacaccttcgaggtgaccggccaggaaacggtcgcccag
    atcaaggctcatgtagcctcactggagggcattgccccggaagatcaagtcgtgctcctg
    gcaggcgcgcccctggaggatgaggccactctgggccagtgcggggtggaggccctgact
    accctggaagtagcaggccgcatgcttggaggtaaagttcatggttccctggcccgtgct
    ggaaaagtgagaggtcagactcctaaggtggccaaacaggagaagaagaagaagaagaca
    ggtcgggctaagcggcggatgcagtacaaccggcgctttgtcaacgttgtgcccaccttt
    ggcaagaagaagggccccaatgccaactcttaagtcttttgtaattctggctttctctaa
    taaaaaagccacttagttca-gnntc

### Output files for usage example 5

### File: trim5.seq

    >myseq
    ctttctcgactccatcttcgcggtagctgggaccgccgttcagtcgccaatatgcagctc
    tttgtccgcgcccaggagctacacaccttcgaggtgaccggccaggaaacggtcgcccag
    atcaaggctcatgtagcctcactggagggcattgccccggaagatcaagtcgtgctcctg
    gcaggcgcgcccctggaggatgaggccactctgggccagtgcggggtggaggccctgact
    accctggaagtagcaggccgcatgcttggaggtaaagttcatggttccctggcccgtgct
    ggaaaagtgagaggtcagactcctaaggtggccaaacaggagaagaagaagaagaagaca
    ggtcgggctaagcggcggatgcagtacaaccggcgctttgtcaacgttgtgcccaccttt
    ggcaagaagaagggccccaatgccaactcttaagtcttttgtaattctggctttctctaa
    taaaaaagccacttagttca-gnntcynnnnnn

## Data files

None.

## Notes

trimseq will remove from a terminal region:

- all gap characters
- X's and N's (in nucleic sequences)
- *'s (optional)
- IUPAC ambiguity codes: B and Z in proteins, M,R,W,S,Y,K,V,H,D and B in nucleic sequences (optional)

Rather than removing individual characters, it removes an entire segment, using a threshold percentage of unwanted characters in a window of a specified size which is moved along the sequence from the ends. The program stops trimming when the percentage of unwanted characters in the moving window drops below the specified threshold percentage.

Thus if the window size is set to 1 and the percentage threshold is 100, no further poor quality regions will be removed. If the window size is set to 5 and the percentage threshold is 40 then the sequence `AAGCTNNNNATT` will be trimmed to `AAGCT`, while `AAGCTNATT` or `AAGCTNNNNATTT` will not be trimmed as less than 40% of the last 5 characters are N's.

After trimming these poor quality regions, it will again then trim off any dangling gap characters from the ends.

## References

None.

## Warnings

None.

## Diagnostic Error Messages

None.

## Exit status

It always exits with status 0.

## Known bugs

None noted.

## See also

Program name | Description
--- | ---
aligncopy | Read and write alignments
aligncopypair | Read and write pairs from alignments
biosed | Replace or delete sequence sections
codcopy | Copy and reformat a codon usage table
cutseq | Remove a section from a sequence
degapseq | Remove non-alphabetic (e.g. gap) characters from sequences
descseq | Alter the name or description of a sequence
entret | Retrieve sequence entries from flatfile databases and files
extractalign | Extract regions from a sequence alignment
extractfeat | Extract features from sequence(s)
extractseq | Extract regions from a sequence
featcopy | Read and write a feature table
featmerge | Merge two overlapping feature tables
featreport | Read and write a feature table
feattext | Return a feature table original text
listor | Write a list file of the logical OR of two sets of sequences
makenucseq | Create random nucleotide sequences
makeprotseq | Create random protein sequences
maskambignuc | Mask all ambiguity characters in nucleotide sequences with N
maskambigprot | Mask all ambiguity characters in protein sequences with X
maskfeat | Write a sequence with masked features
maskseq | Write a sequence with masked regions
newseq | Create a sequence file from a typed-in sequence
nohtml | Remove mark-up (e.g. HTML tags) from an ASCII text file
noreturn | Remove carriage return from ASCII files
nospace | Remove whitespace from an ASCII text file
notab | Replace tabs with spaces in an ASCII text file
notseq | Write to file a subset of an input stream of sequences
nthseq | Write to file a single sequence from an input stream of sequences
nthseqset | Read and write (return) one set of sequences from many
pasteseq | Insert one sequence into another
revseq | Reverse and complement a nucleotide sequence
seqcount | Read and count sequences
seqret | Read and write (return) sequences
seqretsetall | Read and write (return) many sets of sequences
seqretsplit | Read sequences and write them to individual files
sizeseq | Sort sequences by size
skipredundant | Remove redundant sequences from an input set
skipseq | Read and write (return) sequences, skipping first few
splitsource | Split sequence(s) into original source sequences
splitter | Split sequence(s) into smaller sequences
trimest | Remove poly-A tails from nucleotide sequences
trimspace | Remove extra whitespace from an ASCII text file
union | Concatenate multiple sequences into a single sequence
vectorstrip | Remove vectors from the ends of nucleotide sequence(s)
yank | Add a sequence reference (a full USA) to a list file

## Author(s)

Gary Williams formerly at:
MRC Rosalind Franklin Centre for Genomics Research Wellcome Trust Genome Campus, Hinxton, Cambridge, CB10 1SB, UK

Please report all bugs to the EMBOSS bug team (emboss-bug © emboss.open-bio.org) not to the original author.

## History

## Target users

This program is intended to be used by everyone and everything, from naive users to embedded scripts.

## Comments

None